# coding: utf-8

"""
    Orbital transfer API

    Orbital transfer API

    The version of the OpenAPI document: 0.0.6
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from orbital_transfer.models.spacecraft_state import SpacecraftState
from typing import Optional, Set
from typing_extensions import Self

class BoundedEphemeris(BaseModel):
    """
    BoundedEphemeris
    """ # noqa: E501
    phase: Optional[StrictStr] = None
    ephemeris: Optional[List[SpacecraftState]] = None
    orbital_elements_type: Optional[StrictStr] = Field(default=None, alias="orbitalElementsType")
    __properties: ClassVar[List[str]] = ["phase", "ephemeris", "orbitalElementsType"]

    @field_validator('phase')
    def phase_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['COASTING', 'THRUSTING']):
            raise ValueError("must be one of enum values ('COASTING', 'THRUSTING')")
        return value

    @field_validator('orbital_elements_type')
    def orbital_elements_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['MEAN', 'OSCULATING']):
            raise ValueError("must be one of enum values ('MEAN', 'OSCULATING')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BoundedEphemeris from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in ephemeris (list)
        _items = []
        if self.ephemeris:
            for _item in self.ephemeris:
                if _item:
                    _items.append(_item.to_dict())
            _dict['ephemeris'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BoundedEphemeris from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "phase": obj.get("phase"),
            "ephemeris": [SpacecraftState.from_dict(_item) for _item in obj["ephemeris"]] if obj.get("ephemeris") is not None else None,
            "orbitalElementsType": obj.get("orbitalElementsType")
        })
        return _obj


